local o = mOnWardrobe

---------------------------------------------------------------
--  Initialization
---------------------------------------------------------------

---------------------------------------------------------------
--  Create UI
---------------------------------------------------------------

local f = CreateFrame("FRAME", "mOnWD_MiniList", UIParent)
f:SetPoint("CENTER",0,0)
f:SetFrameStrata("high")
f:SetMovable(true)
f:EnableMouse(true)
f:SetClampedToScreen(true)
f:RegisterForDrag("LeftButton")
f:SetScript("OnDragStart", f.StartMoving)
f:SetScript("OnDragStop", f.StopMovingOrSizing)
f:SetWidth(200)
f:SetHeight(250)
f:Hide()

local t = f:CreateTexture(nil, "ARTWORK")
f.bg = t
t:SetColorTexture(0,0,0,0.8)
t:SetAllPoints(f)

local b = CreateFrame("Button", nil, f, "UIPanelCloseButton")
b:SetPoint("TOPRIGHT",f,"TOPRIGHT",8,8)
b:SetScript("OnClick", function()
  f:Hide()
end)

local c = CreateFrame("StatusBar", nil, f)
c:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
c:GetStatusBarTexture():SetHorizTile(false)
c:SetMinMaxValues(0, 100)
c:SetValue(50)
c:SetWidth(f:GetWidth())
c:SetHeight(10 + 4)
c:SetPoint("TOP",f,"TOP", 0, 0)
c:SetStatusBarColor(0,1,0)
f.status = c

local c = f.status:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
c:SetHeight(f.status:GetHeight() - 4)
c:SetWidth(f.status:GetWidth())
c:SetJustifyH("CENTER")
c:SetPoint("TOP", f.status, "TOP", 0, -2)
c:SetText('40 / 100')
local filename, fontHeight, flags = c:GetFont()
c:SetFont(filename, fontHeight, "OUTLINE")
f.status.text = c

local ff = CreateFrame("FRAME", "mOnWD_MiniList_List", f)
ff:SetPoint("TOPLEFT", f.status, "BOTTOMLEFT",0,0)
ff:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT",0,0)
f.list = ff

ff:EnableMouseWheel(true)
ff:SetScript("OnMouseWheel", function(self, delta)
	 if f.N - delta > 0 and f.N - delta < #f.menuItems + 1 then
	 	ff.scrollbar:SetValue(f.N - delta)
	 end
end)

local scrollbar = CreateFrame("Slider", nil, ff, "UIPanelScrollBarTemplate")
scrollbar:SetPoint("TOPRIGHT", ff, "TOPRIGHT", 0, -18)
scrollbar:SetPoint("BOTTOMRIGHT", ff, "BOTTOMRIGHT", 0, 16)
scrollbar:SetMinMaxValues(1, 1)
scrollbar:SetValueStep(1)
scrollbar.scrollStep = 1
scrollbar:SetWidth(16)
scrollbar:SetScript("OnValueChanged", function(self, value)
	 o.GUIopenMiniList(math.floor(value + 0.5))
end)
ff.scrollbar = scrollbar

local fontHeight = select(2, GameFontNormalSmall:GetFont())
local rowHeight = fontHeight + 4
local numRows = math.floor(ff:GetHeight() / rowHeight)
f:SetHeight(numRows * rowHeight + (f:GetHeight() - ff:GetHeight()))
ff.rowHeight = rowHeight
ff.numRows = numRows
ff.rows = {}

local function CreateTableRow(parent, rowHeight, N)
  local row = CreateFrame("FRAME", nil, parent)
  --row:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	row.id = N;
  row:SetHeight(rowHeight)
  row:SetPoint("LEFT")
  row:SetPoint("RIGHT", parent, "RIGHT", -16, 0)

	row:SetScript("OnEnter", function()
      if(row.id) then
        GameTooltip_SetDefaultAnchor(GameTooltip, row)
  			GameTooltip:ClearLines()
				GameTooltip:SetItemByID(row.id);
  			GameTooltip:ClearAllPoints()
  			GameTooltip:SetPoint("BOTTOMLEFT", row, "TOPLEFT")
  			GameTooltip:Show();
      end
		end)

	row:SetScript("OnLeave", function()
			GameTooltip:Hide()
		end)

	local c = row:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
  c:SetHeight(rowHeight)
  c:SetWidth(row:GetWidth() - 2 * 5)
  c:SetJustifyH("LEFT")
  c:SetPoint("LEFT", row, "LEFT", 5, 0)
	c:SetText('test')
	local filename, fontHeight, flags = c:GetFont()
	c:SetFont(filename, fontHeight, "OUTLINE")
	row.text = c

  return row
end

for i=1,numRows do
	local r = CreateTableRow(ff, rowHeight, i)
	if #ff.rows == 0 then
		r:SetPoint("TOP")
	else
		r:SetPoint("TOP", ff.rows[#ff.rows], "BOTTOM")
	end
	table.insert(ff.rows, r)
end

---------------------------------------------------------------
--  Events
---------------------------------------------------------------

---------------------------------------------------------------
--  Methods
---------------------------------------------------------------

o.GUIopenMiniList = function(N, instance, difficulty, dontAffectVisibility)
  local f = mOnWD_MiniList
  local ff = f.list

  if instance then
    f.instance = instance
  end

  if difficulty then
    f.difficulty = difficulty
  end

  if N then
    f.N = N
  end

  if o.instances[f.instance] and o.instances[f.instance][f.difficulty] then
    local data = o.instances[f.instance][f.difficulty]
    f.menuItems = {}
    table.insert(f.menuItems, {name = f.instance, title = true})
    table.insert(f.menuItems, {name = f.difficulty, title = true})
    table.insert(f.menuItems, {name = "", hint = true})
    for k, v in orderedPairs(data) do
      if string.sub(k, 1, 1) ~= '#' then
        if #v > 0 then
          table.insert(f.menuItems, {name = k, category = true})
          for i = 1,#v do
      			local n, itemLink = GetItemInfo(v[i].id)
            table.insert(f.menuItems, {name = n, id = v[i].id, link = itemLink})
          end
          table.insert(f.menuItems, {name = "", category = true})
        end
      end
    end

    local total = data['#total']
    if mOnWDSave.disableProgress then
      f.status.text:SetText(total);
      f.status:SetValue(0)
    else
      local missing = data['#collected']
      local percent = math.floor((missing / total * 100) + 0.5)
      if total == 0 or percent > 100 then percent = 100 end
      f.status.text:SetText(missing .. " / " .. total)
      f.status:SetValue(percent)
    end

    local FirstN = f.N - 1
    ff.scrollbar:SetMinMaxValues(1, math.max(#f.menuItems - ff.numRows + 1, 1))

    for i = 1,ff.numRows do
      local index = i+FirstN
      if f.menuItems[index] then
        ff.rows[i].text:SetText(f.menuItems[index].name)
        ff.rows[i].id = nil
        ff.rows[i].itemLink = nil
        if(f.menuItems[index].category) then
					ff.rows[i].text:SetTextColor(1,1,0.6,1)
        elseif(f.menuItems[index].title) then
  					ff.rows[i].text:SetTextColor(1,0.6,1,1)
        elseif(f.menuItems[index].hint) then
  					ff.rows[i].text:SetTextColor(0.6,0.6,0.6,0.8)
        else
					ff.rows[i].text:SetTextColor(1,1,1,1)
          ff.rows[i].id = f.menuItems[index].id
          ff.rows[i].itemLink = f.menuItems[index].link
        end
      else
        ff.rows[i].text:SetText("")
      end
    end

    if(dontAffectVisibility) then
    else
      f:Show()
    end
  end
end
